﻿using Microsoft.AspNetCore.Identity;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Entities;
using Entities.SQLudeoDB;
using Model.Business;
using System.Diagnostics;
using DbContextLib;
using Microsoft.EntityFrameworkCore;

namespace ModelToEntity
{
    internal static class Extension
    {
        internal static async Task<T?> AddItemAsync<T>(this DbContext context, T? item) where T : class
        {
            if (item == null || await context.Set<T>().ContainsAsync(item))
            {
                return default(T);
            }

            context.Set<T>().Add(item);
            await context.SaveChangesAsync();

            return item;
        }
    }
}